/**
 * Wenn der Wchter um Erlaubnis gefragt wird, liest er so lange
 * Tastatureingaben von der Leinwand, bis er dort sein Passwort
 * entdeckt hat.
 * 
 * @author Bernd Gramlich
 * @version 2010-12-08
 */

import java.awt.event.KeyEvent;

public class Waechter
{
    // Attribut
    private int zustand;

    /**
     * Konstruktor.
     * Hier passiert gar nichts, denn der Wchter wird erst aktiv,
     * wenn er um Erlaubnis gefragt wird.
     */
    public Waechter ()
    {
    }

    /**
     * Der Wchter gibt die Erlaubnis zum Weitermachen, wenn er auf
     * der Leinwand sein Passwort entdeckt hat.
     */
    public void warteAufErlaubnis ()
    {
        /*
	     * Hilfsvariablen:
	     * spielfeld: Die Leinwand, auf der wir spielen.
	     * taste:     Die letzte Taste, die auf der Leinwand gedrckt wurde (als
	     *            Tastaturereignis)
	     * buchstabe: Der Buchstabe, der der Taste entspricht.
	     */
        Leinwand spielfeld = Leinwand.gibLeinwand ();
        KeyEvent taste;
        char     buchstabe;
        
        /*
         * Beginne im Anfangszustand.
         */
        zustand = 1;
        
        /*
         * Solange der Endzustand nicht ereicht ist:
         */
        while (zustand < 8)
        {
            /*
             * Solange keine Taste gedrckt wird, tue nichts.
             */
            while ((taste = spielfeld.tastendruck ()) == null);
            
            /*
             * Ermittle den gedrckten Buchstaben.
             */
            buchstabe = taste.getKeyChar ();
            
            /*
             * Wechsle in einen neuen Zustand, je nachdem, welcher Buchstabe gedrckt wurde.
             */
            switch (zustand)
            {
                case 1:
                switch (buchstabe)
                {
                    case 'b': zustand = 2; break;
                    default : zustand = 1; break;
                }
                break;
                
                case 2:
                switch (buchstabe)
                {
                    case 'a': zustand = 3; break;
                    case 'b': zustand = 2; break;
                    default : zustand = 1; break;
                }
                break;
                
                case 3:
                switch (buchstabe)
                {
                    case 'b': zustand = 2; break;
                    case 'r': zustand = 4; break;
                    default : zustand = 1; break;
                }
                break;
                
                case 4:
                switch (buchstabe)
                {
                    case 'b': zustand = 5; break;
                    default : zustand = 1; break;
                }
                break;
                
                case 5:
                switch (buchstabe)
                {
                    case 'a': zustand = 6; break;
                    case 'b': zustand = 2; break;
                    default : zustand = 1; break;
                }
                break;
                
                case 6:
                switch (buchstabe)
                {
                    case 'b': zustand = 2; break;
                    case 'r': zustand = 7; break;
                    default : zustand = 1; break;
                }
                break;
                
                case 7:
                switch (buchstabe)
                {
                    case 'a': zustand = 8; break;
                    case 'b': zustand = 5; break;
                    default : zustand = 1; break;
                }
                break;
            }
        }
    }
}
